(* ::Package:: *)

(* ::Subtitle:: *)
(*Pfaffians from MM *)


SetDirectory @ NotebookDirectory[];
Get["../gkz_utils/gkz.m"]
Get["FiniteFlow.m"]


(* ::Text:: *)
(*dir = x8*)


dir = 2


(* ::Section:: *)
(*Macaulay data*)


(* ::Subsection:: *)
(*import*)


data = mmimport["macaulay_data.txt"];
{m1, m2, ext, std} = data;


Dimensions /@ {m1, m2, ext, std} // Column


(* ::Text:: *)
(*all monomials*)


mons = Join[ext, std];


(* ::Subsection:: *)
(*numerics*)


params = m1 // Variables
num = numrep[params]


m1n = m1 // num;
(*m1n // SparseArray // MatrixPlot[#, ColorFunction->"Monochrome"]&*)


MatrixRank[m1n]


(* ::Subsection:: *)
(*c1' and c2'*)


(* ::Text:: *)
(*d_xi \[Bullet] std =  c12' \[Bullet] mons = c1' \[Bullet] ext + c2' \[Bullet] std*)


c1[dir_]  := coeffarr[dir,ext];
c2[dir_]  := coeffarr[dir,std];
c12[dir_] := coeffarr[dir,mons];


(* ::Text:: *)
(*C1' and C2'*)


c1[dir] // Dimensions
c2[dir] // Dimensions


(* ::Text:: *)
(*check*)


c12[dir].mons - der[std,dir]
c12[dir].mons - c1[dir].ext - c2[dir].std


(* ::Section:: *)
(*Matrix equation*)


(* ::Subsection:: *)
(*setup*)


(* ::Text:: *)
(*independent rows*)


rows = indrows[m1n]
m1ind = m1[[rows]];


(* ::Text:: *)
(*wish to solve for c[i,j]*)


cij = Table[c[i, j], {i, Length@std}, {j, First@Dimensions@m1ind}];


(* ::Text:: *)
(*meq == 0*)


Clear[meq]

meq[dir_] := meq[dir] = c1[dir] - cij . m1ind // DeleteCases[#,0]& // Flatten;


(* ::Subsection:: *)
(*naive solution*)


(* ::Text:: *)
(*solution*)


Clear[sol,csol]

sol[dir_] := sol[dir] = FFSparseSolve[
	meq[dir] == 0 // Thread,
	meq[dir] // filter[_c]
]

csol[dir_] := csol[dir] = cij //. Dispatch[sol@dir] // Factor;


(* ::Text:: *)
(*update the matrix*)


csol[dir];
%[[All,2]] // filter[_c]


(* ::Text:: *)
(*check that solution satisfies matrix equation*)


c1[dir] - num[csol@dir] . num[m1ind] // Flatten // DeleteDuplicates


(* ::Section:: *)
(*Pfaffian*)


(* ::Subsection:: *)
(*P_x8*)


(* ::Text:: *)
(*independent rows for m2*)


m2ind = m2[[rows]];


(* ::Text:: *)
(*try with ?FFAlgMatMul*)


p[dir_] := p[dir] = c2[dir] - csol[dir].m2ind // Factor;


(* ::Text:: *)
(*rank check*)


p[dir];
p[dir] // num // MatrixRank


(* ::Subsection:: *)
(*all dirs*)


dirs = {1,2,3,4,5}


pdirs = p /@ dirs


Export["pfaffian_std.m", pdirs]


(* ::Text:: *)
(*integrability check*)


(*D[p[3],x10] + p[3].p[4] - (D[p[4],x9] + p[4].p[3]) // num*)
